package com.hotwj.platform.config.riskLevelConfig.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.hotwj.platform.config.riskLevelConfig.domain.HotRiskLevelConfig;
import com.hotwj.platform.config.riskLevelConfig.domain.bo.HotRiskLevelConfigBo;
import com.hotwj.platform.config.riskLevelConfig.domain.vo.HotRiskLevelConfigVo;
import com.hotwj.platform.config.riskLevelConfig.mapper.HotRiskLevelConfigMapper;
import com.hotwj.platform.config.riskLevelConfig.service.IHotRiskLevelConfigService;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.PageQuery;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.springframework.stereotype.Service;

import java.util.Collection;
import java.util.List;
import java.util.Map;

/**
 * 风险等级划分Service业务层处理
 *
 * @author shihongwei
 * @date 2026-01-04
 */
@Slf4j
@RequiredArgsConstructor
@Service
public class HotRiskLevelConfigServiceImpl implements IHotRiskLevelConfigService {

    private final HotRiskLevelConfigMapper baseMapper;

    /**
     * 查询风险等级划分
     *
     * @param id 主键
     * @return 风险等级划分
     */
    @Override
    public HotRiskLevelConfigVo queryById(Long id) {
        return baseMapper.selectVoById(id);
    }

    /**
     * 分页查询风险等级划分列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 风险等级划分分页列表
     */
    @Override
    public TableDataInfo<HotRiskLevelConfigVo> queryPageList(HotRiskLevelConfigBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<HotRiskLevelConfig> lqw = buildQueryWrapper(bo);
        Page<HotRiskLevelConfigVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的风险等级划分列表
     *
     * @param bo 查询条件
     * @return 风险等级划分列表
     */
    @Override
    public List<HotRiskLevelConfigVo> queryList(HotRiskLevelConfigBo bo) {
        LambdaQueryWrapper<HotRiskLevelConfig> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<HotRiskLevelConfig> buildQueryWrapper(HotRiskLevelConfigBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<HotRiskLevelConfig> lqw = Wrappers.lambdaQuery();
        lqw.orderByDesc(HotRiskLevelConfig::getLevelValue);
        lqw.eq(bo.getLevelValue() != null, HotRiskLevelConfig::getLevelValue, bo.getLevelValue());
        lqw.like(StringUtils.isNotBlank(bo.getLevelName()), HotRiskLevelConfig::getLevelName, bo.getLevelName());
        lqw.eq(StringUtils.isNotBlank(bo.getDescription()), HotRiskLevelConfig::getDescription, bo.getDescription());
        lqw.eq(bo.getType() != null, HotRiskLevelConfig::getType, bo.getType());
        lqw.eq(bo.getIsDeleted() != null, HotRiskLevelConfig::getIsDeleted, bo.getIsDeleted());
        return lqw;
    }

    /**
     * 新增风险等级划分
     *
     * @param bo 风险等级划分
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(HotRiskLevelConfigBo bo) {
        HotRiskLevelConfig add = MapstructUtils.convert(bo, HotRiskLevelConfig.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改风险等级划分
     *
     * @param bo 风险等级划分
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(HotRiskLevelConfigBo bo) {
        HotRiskLevelConfig update = MapstructUtils.convert(bo, HotRiskLevelConfig.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(HotRiskLevelConfig entity) {
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除风险等级划分信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if (isValid) {
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }
}
